﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Threading.Tasks;
using Foundation;
using Syncfusion.SfChart.iOS;
using UIKit;

namespace Chart_GettingStarted
{
    public partial class ViewController : UIViewController
    {
        protected ViewController(IntPtr handle) : base(handle)
        {
            // Note: this .ctor should not contain any initialization logic.
        }

        DataModel model = new DataModel();
        SFChart chart;

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();

            chart = new SFChart();
            SFCategoryAxis primaryAxis = new SFCategoryAxis()
            {
            };
            primaryAxis.Title.Text = new NSString("XValue");
            chart.PrimaryAxis = primaryAxis;

            SFNumericalAxis secondaryAxis = new SFNumericalAxis();
            secondaryAxis.Title.Text = new NSString("Value");
            chart.SecondaryAxis = secondaryAxis;

            var series = new SFLineSeries();
            series.ItemsSource = model.Data;
            series.XBindingPath = "XValue";
            series.YBindingPath = "YValue";
            series.DataMarker.ShowLabel = true;
            chart.Series.Add(series);

            series.DataMarkerLabelCreated += Series_DataMarkerLabelCreated;

            this.View.AddSubview(chart);
        }

        void Series_DataMarkerLabelCreated(object sender, SFSeries.DataMarkerLabelCreatedEventArgs e)
        {
            var data = e.DataMarkerLabel.Data as ChartDataModel;
            if(data != null)
            {
                if(data.XValue == 5 && data.YValue == 20 )
                {
                    e.DataMarkerLabel.Label = "TextAnnoatation";
                }
                else
                {
                    e.DataMarkerLabel.LabelStyle = new SFDataMarkerLabelStyle();
                    e.DataMarkerLabel.LabelStyle.Color = UIColor.Clear;
                    e.DataMarkerLabel.BackgroundColor = UIColor.Clear;
                    e.DataMarkerLabel.Label = string.Empty;
                }
            }

        }


        public override void ViewDidLayoutSubviews()
        {
            foreach (var view in this.View.Subviews)
            {
                view.Frame = View.Bounds;
            }

            base.ViewDidLayoutSubviews();
        }

        public override void ViewWillAppear(bool animated)
        {

            base.ViewWillAppear(animated);
        }

        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
        }

        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }

        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
            // Release any cached data, images, etc that aren't in use.
        }

       

    }

}
